<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>WebSocket Command Center</title>
    <style>
        body { font-family: Arial, sans-serif; }
        #logOutput {
            white-space: pre-wrap;
            background-color: #f0f0f0;
            padding: 10px;
            margin-top: 10px;
            height: 580px; /* Adjust based on your screen size */
            overflow-y: auto; /* Enable scrolling */
            border: 1px solid #ccc; /* Optional: adds a border around the log area */
        }
        #clients { margin-bottom: 20px; }
        input[type="text"] { width: calc(100% - 115px); } /* Adjust input width */
        button { width: 100px; } /* Adjust button width */
    </style>
</head>
<body>
<button style="float:right" onclick="logout()">Logout</button>
<h2>Connected Clients</h2>
<ul id="clients"></ul>

<h2>Send Command</h2>
<input type="text" id="commandInput" placeholder="Enter command" onkeypress="handleKeyPress(event)">
<button onclick="sendCommand()">Send</button>

<h2>Logs</h2>
<div id="logOutput"></div>

<script>
    async function fetchClients() {
        const response = await fetch('/clients');
        const clients = await response.json();
        const clientsList = document.getElementById('clients');
        clientsList.innerHTML = ''; // Clear existing list
        Object.keys(clients).forEach((clientId, index) => {
            const li = document.createElement('li');
            li.innerHTML = `${index + 1}. ${clientId} - IP: ${clients[clientId].ip || 'Unknown'}`;
            li.onclick = () => setActiveClient(clientId); // Add click event to set active client
            li.style.cursor = 'pointer'; // Change cursor on hover
            clientsList.appendChild(li);
        });
    }

    async function setActiveClient(clientId) {
        const response = await fetch('/set-active-client', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json'
            },
            body: JSON.stringify({ clientId })
        });
        const result = await response.json();
        console.log(result.message); // Log the response from the server
        // Optionally, provide feedback in the UI that the active client has changed
    }

    async function sendCommand() {
        const input = document.getElementById('commandInput');
        const command = input.value;
        const response = await fetch('/send-command', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json'
            },
            body: JSON.stringify({ command })
        });
        const result = await response.json();
        console.log(result);
        input.value = ''; // Clear input field after sending
        fetchLogs(); // Fetch logs to see the new command
    }

    async function fetchLogs() {
        const response = await fetch('/logs');
        const newLogs = await response.json();
        const logOutputElement = document.getElementById('logOutput');
        const shouldScroll = logOutputElement.scrollHeight - logOutputElement.clientHeight <= logOutputElement.scrollTop + 1; // Check if we're at the bottom
        logOutputElement.textContent = newLogs.join('\n');

        if (shouldScroll) {
            logOutputElement.scrollTop = logOutputElement.scrollHeight; // Scroll to the bottom only if we were already there
        }
    }

    function handleKeyPress(event) {
        if (event.key === 'Enter') {
            sendCommand();
        }
    }

    function logout() {
        // Making a request to an endpoint that doesn't exist or to the logout endpoint you define in your server
        // This should cause the browser to prompt for login again due to the 401 status, which effectively logs the user out
        fetch('/logout', {
            headers: {
                'Authorization': 'Basic ' + btoa('logout:logout')  // Sending a dummy request
            }
        }).then(response => {
            if (response.status === 401) {
                // Redirect to login page or home page as required
                window.location.href = '/login.html'; // Assuming you have a login page setup
            }
        }).catch(error => console.error('Error logging out:', error));
    }

    // Fetch clients and logs every 5 seconds
    setInterval(fetchClients, 5000);
    setInterval(fetchLogs, 5000);
    fetchClients(); // Fetch immediately on page load
    fetchLogs(); // Fetch immediately on page load
</script>
</body>
</html>
